Driver not found in Ubuntu kernel does not detect interface

Bug #1745927 reported by bugproxy on 2018-01-29
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
The Ubuntu-power-systems project
High
Canonical Foundations Team
debian-installer (Ubuntu)
High
Canonical Kernel Team
linux (Ubuntu)
High
Canonical Kernel Team

Bug Description

== Comment: #0 - Harish Sriram
--Problem Description---
kernel does not detect interface in Ubuntu, driver missing in kernel

Contact Information = <email address hidden>

---Issue observed---
While installing Ubuntu on a machine with Chelsio card, ubuntu-installer fails to show the interface name - probable cause would be due to missing driver in Ubuntu kernel.

Machine Type = Tuleta/Power 8 BML

----Additional Info-----
Installer Shell
-------------------
BusyBox v1.27.2 (Ubuntu 1:1.27.2-2ubuntu3) built-in shell (ash)
Enter 'help' for a list of built-in commands.

~ # ip a
1: lo: <LOOPBACK> mtu 65536 qdisc noop qlen 1000
    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
2: enP5p9s0f0: <BROADCAST,MULTICAST> mtu 1500 qdisc mq qlen 1000
    link/ether 98:be:94:02:09:7c brd ff:ff:ff:ff:ff:ff
3: enP5p9s0f1: <BROADCAST,MULTICAST> mtu 1500 qdisc mq qlen 1000
    link/ether 98:be:94:02:09:7d brd ff:ff:ff:ff:ff:ff
4: enP5p9s0f2: <BROADCAST,MULTICAST> mtu 1500 qdisc mq qlen 1000
    link/ether 98:be:94:02:09:7e brd ff:ff:ff:ff:ff:ff
5: enP5p9s0f3: <BROADCAST,MULTICAST> mtu 1500 qdisc mq qlen 1000
    link/ether 98:be:94:02:09:7f brd ff:ff:ff:ff:ff:ff

~ # lspci -k
0000:00:00.0 PCI bridge: IBM Device 03dc
0001:00:00.0 PCI bridge: IBM Device 03dc
0001:01:00.0 PCI bridge: PLX Technology, Inc. PEX 8732 32-lane, 8-Port PCI Express Gen 3 (8.0 GT/s) Switch (rev ca)
0001:02:01.0 PCI bridge: PLX Technology, Inc. PEX 8732 32-lane, 8-Port PCI Express Gen 3 (8.0 GT/s) Switch (rev ca)
0001:02:08.0 PCI bridge: PLX Technology, Inc. PEX 8732 32-lane, 8-Port PCI Express Gen 3 (8.0 GT/s) Switch (rev ca)
0001:02:09.0 PCI bridge: PLX Technology, Inc. PEX 8732 32-lane, 8-Port PCI Express Gen 3 (8.0 GT/s) Switch (rev ca)
0001:03:00.0 Ethernet controller: Chelsio Communications Inc T422-CR Unified Wire Ethernet Controller
 Subsystem: IBM Device 03e5
0001:03:00.1 Ethernet controller: Chelsio Communications Inc T422-CR Unified Wire Ethernet Controller
 Subsystem: IBM Device 03e5
0001:03:00.2 Ethernet controller: Chelsio Communications Inc Device 4102
 Subsystem: IBM Device 03e5
0001:03:00.3 Ethernet controller: Chelsio Communications Inc Device 4102
 Subsystem: IBM Device 03e5
0001:03:00.4 Ethernet controller: Chelsio Communications Inc T422-CR Unified Wire Ethernet Controller
 Subsystem: IBM Device 03e5
0001:03:00.5 SCSI storage controller: Chelsio Communications Inc T422-CR Unified Wire Storage Controller
 Subsystem: IBM Device 03e5
0001:03:00.6 Fibre Channel: Chelsio Communications Inc T422-CR Unified Wire Storage Controller
 Subsystem: IBM Device 03e5
0001:03:00.7 Ethernet controller: Chelsio Communications Inc Device 0000
 Subsystem: IBM Device 03e5
0001:04:00.0 RAID bus controller: IBM PCI-E IPR SAS Adapter (ASIC) (rev 02)
 Subsystem: IBM Device 03ff
0004:00:00.0 PCI bridge: IBM Device 03dc
0004:01:00.0 PCI bridge: Integrated Device Technology, Inc. [IDT] PES16T4A/4T4G2 PCI Express Gen2 Switch (rev 02)
0004:02:02.0 PCI bridge: Integrated Device Technology, Inc. [IDT] PES16T4A/4T4G2 PCI Express Gen2 Switch (rev 02)
0004:02:03.0 PCI bridge: Integrated Device Technology, Inc. [IDT] PES16T4A/4T4G2 PCI Express Gen2 Switch (rev 02)
0004:03:00.0 Fibre Channel: QLogic Corp. ISP2532-based 8Gb Fibre Channel to PCI Express HBA (rev 02)
 Subsystem: IBM Device 041e
0004:03:00.1 Fibre Channel: QLogic Corp. ISP2532-based 8Gb Fibre Channel to PCI Express HBA (rev 02)
 Subsystem: IBM Device 041e
0004:04:00.0 Fibre Channel: QLogic Corp. ISP2532-based 8Gb Fibre Channel to PCI Express HBA (rev 02)
 Subsystem: IBM Device 041e
0004:04:00.1 Fibre Channel: QLogic Corp. ISP2532-based 8Gb Fibre Channel to PCI Express HBA (rev 02)
 Subsystem: IBM Device 041e
0005:00:00.0 PCI bridge: IBM Device 03dc
0005:01:00.0 PCI bridge: PLX Technology, Inc. PEX 8748 48-Lane, 12-Port PCI Express Gen 3 (8 GT/s) Switch, 27 x 27mm FCBGA (rev ca)
0005:02:01.0 PCI bridge: PLX Technology, Inc. PEX 8748 48-Lane, 12-Port PCI Express Gen 3 (8 GT/s) Switch, 27 x 27mm FCBGA (rev ca)
0005:02:08.0 PCI bridge: PLX Technology, Inc. PEX 8748 48-Lane, 12-Port PCI Express Gen 3 (8 GT/s) Switch, 27 x 27mm FCBGA (rev ca)
0005:02:09.0 PCI bridge: PLX Technology, Inc. PEX 8748 48-Lane, 12-Port PCI Express Gen 3 (8 GT/s) Switch, 27 x 27mm FCBGA (rev ca)
0005:02:10.0 PCI bridge: PLX Technology, Inc. PEX 8748 48-Lane, 12-Port PCI Express Gen 3 (8 GT/s) Switch, 27 x 27mm FCBGA (rev ca)
0005:02:11.0 PCI bridge: PLX Technology, Inc. PEX 8748 48-Lane, 12-Port PCI Express Gen 3 (8 GT/s) Switch, 27 x 27mm FCBGA (rev ca)
0005:03:00.0 USB controller: Texas Instruments TUSB73x0 SuperSpeed USB 3.0 xHCI Host Controller (rev 02)
 Subsystem: IBM Device 04b2
 Kernel driver in use: xhci_hcd
0005:09:00.0 Ethernet controller: Broadcom Limited NetXtreme BCM5719 Gigabit Ethernet PCIe (rev 01)
 Subsystem: IBM Device 0420
 Kernel driver in use: tg3
 Kernel modules: tg3
0005:09:00.1 Ethernet controller: Broadcom Limited NetXtreme BCM5719 Gigabit Ethernet PCIe (rev 01)
 Subsystem: IBM Device 0420
 Kernel driver in use: tg3
 Kernel modules: tg3
0005:09:00.2 Ethernet controller: Broadcom Limited NetXtreme BCM5719 Gigabit Ethernet PCIe (rev 01)
 Subsystem: IBM Device 0420
 Kernel driver in use: tg3
 Kernel modules: tg3
0005:09:00.3 Ethernet controller: Broadcom Limited NetXtreme BCM5719 Gigabit Ethernet PCIe (rev 01)
 Subsystem: IBM Device 0420
 Kernel driver in use: tg3
 Kernel modules: tg3
0040:00:00.0 PCI bridge: IBM Device 03dc
0044:00:00.0 PCI bridge: IBM Device 03dc
0045:00:00.0 PCI bridge: IBM Device 03dc

Interface up in petitboot
----------------------------
/ # ip a
1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue qlen 1
    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
    inet 127.0.0.1/8 scope host lo
       valid_lft forever preferred_lft forever
2: enP3p9s0f0: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 98:be:94:02:09:7c brd ff:ff:ff:ff:ff:ff
3: enP3p9s0f1: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 98:be:94:02:09:7d brd ff:ff:ff:ff:ff:ff
4: enP3p9s0f2: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 98:be:94:02:09:7e brd ff:ff:ff:ff:ff:ff
5: enP3p9s0f3: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 98:be:94:02:09:7f brd ff:ff:ff:ff:ff:ff
6: tunl0@NONE: <NOARP> mtu 1480 qdisc noop qlen 1
    link/ipip 0.0.0.0 brd 0.0.0.0
7: enP1p3s0f4: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 5c:f3:fc:ee:75:80 brd ff:ff:ff:ff:ff:ff
8: enP1p3s0f4d1: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 5c:f3:fc:ee:75:88 brd ff:ff:ff:ff:ff:ff
9: enP1p3s0f4d2: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc mq qlen 1000
    link/ether 5c:f3:fc:ee:75:90 brd ff:ff:ff:ff:ff:ff
    inet 9.114.12.193/22 scope global enP1p3s0f4d2
       valid_lft forever preferred_lft forever
10: enP1p3s0f4d3: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 1000
    link/ether 5c:f3:fc:ee:75:98 brd ff:ff:ff:ff:ff:ff

# ethtool -i enP1p3s0f4d2
driver: cxgb4
version: 2.0.0-ko
firmware-version: 1.16.63.0, TP 0.1.9.4
expansion-rom-version: 0.0.0.0
bus-info: 0001:03:00.4
supports-statistics: yes
supports-test: no
supports-eeprom-access: yes
supports-register-dump: yes
supports-priv-flags: no

Which corresponds to

0001:03:00.0 Ethernet controller [0200]: Chelsio Communications Inc T422-CR Unified Wire Ethernet Controller [1425:4002]
0001:03:00.1 Ethernet controller [0200]: Chelsio Communications Inc T422-CR Unified Wire Ethernet Controller [1425:4002]
0001:03:00.2 Ethernet controller [0200]: Chelsio Communications Inc Device [1425:4102]
0001:03:00.3 Ethernet controller [0200]: Chelsio Communications Inc Device [1425:4102]
0001:03:00.4 Ethernet controller [0200]: Chelsio Communications Inc T422-CR Unified Wire Ethernet Controller [1425:4402]

Step to reproduce: Install Ubuntu 18.04 on a BML with Chelsio card interface UP.

---Expected---
Kernel to detect the interface.

---Actual---
Installation fails as interface is not detected from the card.

CVE References

bugproxy (bugproxy) wrote : dmesg

Default Comment by Bridge

tags: added: architecture-ppc64le bugnameltc-163845 severity-high targetmilestone-inin---
Changed in ubuntu:
assignee: nobody → Ubuntu on IBM Power Systems Bug Triage (ubuntu-power-triage)
affects: ubuntu → debian-installer (Ubuntu)
Changed in ubuntu-power-systems:
importance: Undecided → High
assignee: nobody → Canonical Foundations Team (canonical-foundations)
status: New → Triaged
tags: added: triage-g

------- Comment From <email address hidden> 2018-01-29 09:28 EDT-------
What is the config option that needs to be switched to have this enabled in the installer kernel?

Steve Langasek (vorlon) wrote :

The set of drivers available in the installer is configured in the kernel package; reassigning.

affects: debian-installer (Ubuntu) → linux (Ubuntu)
Changed in ubuntu-power-systems:
assignee: Canonical Foundations Team (canonical-foundations) → nobody
Changed in ubuntu-power-systems:
assignee: nobody → Canonical Kernel Team (canonical-kernel-team)
Joseph Salisbury (jsalisbury) wrote :

Would it be possible for you to test the latest upstream kernel? Refer to https://wiki.ubuntu.com/KernelMainlineBuilds . Please test the latest v4.15 kernel[0].

If this bug is fixed in the mainline kernel, please add the following tag 'kernel-fixed-upstream'.

If the mainline kernel does not fix this bug, please add the tag: 'kernel-bug-exists-upstream'.

Once testing of the upstream kernel is complete, please mark this bug as "Confirmed".

Thanks in advance.

[0] http://kernel.ubuntu.com/~kernel-ppa/mainline/v4.15

Changed in linux (Ubuntu):
importance: Undecided → High
tags: added: kernel-da-key
Changed in linux (Ubuntu):
status: New → Triaged
Dimitri John Ledkov (xnox) wrote :

There are a few steps that need to happen:
1) determine which kernel modules are required for that hardware
2) check if those kernel modules are build and available from the regular userspace package
3) check if those kernel modules are included in the udeb kernel package for the installer
4) check that installer correctly detects and loads those missing modules and/or said udebs are included in the d-i built itself.

If I am reading the provided debug output right, "cxgb4" driver is required. I see that there is

kernel/drivers/net/ethernet/chelsio/cxgb4/cxgb4.ko

built in the regular kernel build, and shipped in the -extra package.
(there are a few others as well e.g. iw_cxgb4, cxgb4i, cxgb4vf)

However, I do not see net/ethernet/chelsio/* included in the nic-modules-4.13.0-32-generic-di_4.13.0-32.35_ppc64el.udeb package as used by the installer.

Therefore I believe the scope of this bug is to make sure that net/ethernet/chelsio/* is shipped in the nic-modules udeb package.

Then a d-i rebuild will be needed.

Then the bug reporter can re-validate if this issue becomes resolved.

Manoj Iyer (manjo) on 2018-02-05
Changed in linux (Ubuntu):
assignee: Ubuntu on IBM Power Systems Bug Triage (ubuntu-power-triage) → Canonical Kernel Team (canonical-kernel-team)
Changed in debian-installer (Ubuntu):
assignee: nobody → Canonical Kernel Team (canonical-kernel-team)
importance: Undecided → High
bugproxy (bugproxy) on 2018-02-12
tags: added: targetmilestone-inin1804
removed: targetmilestone-inin---
tags: added: kernel-key
removed: kernel-da-key
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2018-02-22 00:25 EDT-------
What is the next steps on this? Do we get "cxgb4" driver added as part of installer and it gets resolved in next build? If so any target date?

I have sent a patch to the mailing list. That means an udeb package will be built when a new bionic kernel is released. Then, when a new d-i image is built with that new kernel, it will be possible to test it.

Cascardo.

Seth Forshee (sforshee) on 2018-02-26
Changed in linux (Ubuntu):
status: Triaged → Fix Committed
Manoj Iyer (manjo) wrote :

IBM, The fix for this issue was released can you please test with the latest debian-installer and report back here with status ?

Seth Forshee (sforshee) wrote :

@manjo: The fix has been committed but no kernel with the fix has been released yet, so asking for testing is premature.

bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2018-03-13 07:10 EDT-------
(In reply to comment #14)
> @manjo: The fix has been committed but no kernel with the fix has been
> released yet, so asking for testing is premature.

Or if you can provide the fix (patched kernel) as well work out for us to validate internally.

Launchpad Janitor (janitor) wrote :
Download full text (40.0 KiB)

This bug was fixed in the package linux - 4.15.0-12.13

---------------
linux (4.15.0-12.13) bionic; urgency=medium

  * linux: 4.15.0-12.13 -proposed tracker (LP: #1754059)

  * CONFIG_EFI=y on armhf (LP: #1726362)
    - [Config] CONFIG_EFI=y on armhf, reconcile secureboot EFI settings

  * ppc64el: Support firmware disable of RFI flush (LP: #1751994)
    - powerpc/pseries: Support firmware disable of RFI flush
    - powerpc/powernv: Support firmware disable of RFI flush

  * [Feature] CFL/CNL (PCH:CNP-H): New GPIO Commit added (GPIO Driver needed)
    (LP: #1751714)
    - gpio / ACPI: Drop unnecessary ACPI GPIO to Linux GPIO translation
    - pinctrl: intel: Allow custom GPIO base for pad groups
    - pinctrl: cannonlake: Align GPIO number space with Windows

  * [Feature] Add xHCI debug device support in the driver (LP: #1730832)
    - usb: xhci: Make some static functions global
    - usb: xhci: Add DbC support in xHCI driver
    - [Config] USB_XHCI_DBGCAP=y for commit mainline dfba2174dc42.

  * [SRU] Lenovo E41 Mic mute hotkey is not responding (LP: #1753347)
    - platform/x86: ideapad-laptop: Increase timeout to wait for EC answer

  * headset mic can't be detected on two Dell machines (LP: #1748807)
    - ALSA: hda - Fix a wrong FIXUP for alc289 on Dell machines

  * hisi_sas: Add disk LED support (LP: #1752695)
    - scsi: hisi_sas: directly attached disk LED feature for v2 hw

  * [Feature] [Graphics]Whiskey Lake (Coffelake-U 4+2) new PCI Device ID adds
    (LP: #1742561)
    - drm/i915/cfl: Adding more Coffee Lake PCI IDs.

  * [Bug] [USB Function][CFL-CNL PCH]Stall Error and USB Transaction Error in
    trace, Disable of device-initiated U1/U2 failed and rebind failed: -517
    during suspend/resume with usb storage. (LP: #1730599)
    - usb: Don't print a warning if interface driver rebind is deferred at resume

  * retpoline: ignore %cs:0xNNN constant indirections (LP: #1752655)
    - [Packaging] retpoline -- elide %cs:0xNNNN constants on i386
    - [Config] retpoline -- clean up i386 retpoline files

  * hisilicon hibmc regression due to ea642c3216cb ("drm/ttm: add io_mem_pfn
    callback") (LP: #1738334)
    - drm/ttm: add ttm_bo_io_mem_pfn to check io_mem_pfn

  * [Asus UX360UA] battery status in unity-panel is not changing when battery is
    being charged (LP: #1661876) // AC adapter status not detected on Asus
    ZenBook UX410UAK (LP: #1745032)
    - ACPI / battery: Add quirk for Asus UX360UA and UX410UAK

  * ASUS UX305LA - Battery state not detected correctly (LP: #1482390)
    - ACPI / battery: Add quirk for Asus GL502VSK and UX305LA

  * [18.04 FEAT] Automatically detect layer2 setting in the qeth device driver
    (LP: #1747639)
    - s390/diag: add diag26c support for VNIC info
    - s390/qeth: support early setup for z/VM NICs

  * Bionic update to v4.15.7 stable release (LP: #1752317)
    - netfilter: drop outermost socket lock in getsockopt()
    - arm64: mm: don't write garbage into TTBR1_EL1 register
    - kconfig.h: Include compiler types to avoid missed struct attributes
    - MIPS: boot: Define __ASSEMBLY__ for its.S build
    - xtensa: fix high memory/reserved memory collision
    - scsi: ibmvfc: fix misde...

Changed in linux (Ubuntu):
status: Fix Committed → Fix Released
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2018-03-16 02:47 EDT-------
With the proposed installer, the Chelsio card can be seen in the installer.

? Primary network interface: ?
? ?
? enP1p3s0f4: Chelsio Communications Inc T422-CR Unified Wire Ether ?
? enP1p3s0f4d1: Chelsio Communications Inc T422-CR Unified Wire Eth ?
? enP1p3s0f4d2: Chelsio Communications Inc T422-CR Unified Wire Eth ?
? enP1p3s0f4d3: Chelsio Communications Inc T422-CR Unified Wire Eth ?

Once the patches are in mainline, this bug can be marked as resolved.

Thanks,
Harish

Changed in ubuntu-power-systems:
assignee: Canonical Kernel Team (canonical-kernel-team) → Canonical Foundations Team (canonical-foundations)
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2018-03-25 15:48 EDT-------
Based on previous comments from Harish, fix is ready in proposed build, please move this to fix ready state.

Steve Langasek (vorlon) wrote :

The fixed version of the installer also reached the bionic release pocket at the same time as the fixed kernel.

Changed in debian-installer (Ubuntu):
status: New → Fix Released
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2018-03-26 06:42 EDT-------
(In reply to comment #17)
> With the proposed installer, the Chelsio card can be seen in the installer.
>
> ? Primary network interface: ?
> ? ?
> ? enP1p3s0f4: Chelsio Communications Inc T422-CR Unified Wire Ether ?
> ? enP1p3s0f4d1: Chelsio Communications Inc T422-CR Unified Wire Eth ?
> ? enP1p3s0f4d2: Chelsio Communications Inc T422-CR Unified Wire Eth ?
> ? enP1p3s0f4d3: Chelsio Communications Inc T422-CR Unified Wire Eth ?
>
> Once the patches are in mainline, this bug can be marked as resolved.
>
> Thanks,
> Harish

Issue is not seen anymore with the patches included in mainline Ubuntu 18.04 stream. Hence, Bug can be closed.

Thanks,
Harish

Manoj Iyer (manjo) on 2018-04-05
Changed in ubuntu-power-systems:
status: Triaged → Fix Released
Brad Figg (brad-figg) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-bionic' to 'verification-done-bionic'. If the problem still exists, change the tag 'verification-needed-bionic' to 'verification-failed-bionic'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-bionic
Andy Whitcroft (apw) on 2019-02-14
tags: added: kernel-fixup-verification-needed-bionic
removed: verification-needed-bionic
Brad Figg (brad-figg) on 2019-02-14
tags: added: verification-needed-bionic
Andy Whitcroft (apw) wrote :

This bug was erroneously marked for verification in bionic; verification is not required and verification-needed-bionic is being removed.

tags: removed: verification-needed-bionic
tags: added: verification-done-bionic
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Bug attachments